﻿unit FMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, AdvUtil, Vcl.Grids, AdvObj, BaseGrid,
  AdvGrid, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    MyAdvGrid: TAdvStringGrid;
    Panel1: TPanel;
    btnInit: TButton;
    btnHideCols: TButton;
    btnRemoveComments: TButton;
    btnShowCols: TButton;
    RemoveAllCommentsFixed: TButton;
    procedure btnInitClick(Sender: TObject);
    procedure btnHideColsClick(Sender: TObject);
    procedure btnRemoveAllButtonsClick(Sender: TObject);
    procedure btnShowColsClick(Sender: TObject);
    procedure RemoveAllCommentsFixedClick(Sender: TObject);
  private
    fMyRow: Integer;
    procedure InitGrid;
  public
    { Déclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ TForm1 }

procedure TForm1.InitGrid;
var
  i: Integer;
begin
  MyAdvGrid.UnHideColumns(0, MyAdvGrid.AllColCount - 1);
  MyAdvGrid.ColCount := 5;
  MyAdvGrid.RowCount := 6;

  // Add 2 columns
  for i := 1 to 2 do
    MyAdvGrid.AddColumn;

  // Add 3 rows
  for i := 1 to 3 do
    MyAdvGrid.AddRow;

  // Define headers
  for i := 0 to MyAdvGrid.AllColCount - 1 do
    MyAdvGrid.Cols[i].Text := Format('Col %d', [i]);

  // Add Comments on cells
  for i := 1 to MyAdvGrid.AllColCount - 1 do
    MyAdvGrid.AddComment(i, fMyRow, Format('Comment %d', [i]));
end;

procedure TForm1.btnHideColsClick(Sender: TObject);
begin
  MyAdvGrid.HideColumn(2);
  MyAdvGrid.HideColumn(4);
end;

procedure TForm1.btnInitClick(Sender: TObject);
begin
  fMyRow := 1;
  InitGrid;
end;

procedure TForm1.btnRemoveAllButtonsClick(Sender: TObject);
begin
  MyAdvGrid.RemoveAllComments;
end;

procedure TForm1.btnShowColsClick(Sender: TObject);
begin
  MyAdvGrid.UnHideColumns(0, MyAdvGrid.AllColCount - 1);
end;

procedure TForm1.RemoveAllCommentsFixedClick(Sender: TObject);
var
  i,j: Integer;
begin
  // It's a copy of the procedure TAdvStringGrid.RemoveAllComments, with a possible correction
  for i := 0 to MyAdvGrid.AllColCount - 1 do     {AllColCount instead of ColCount}
    for j := 0 to MyAdvGrid.AllRowCount - 1 do        {AllRowCount instead of RowCount}
      MyAdvGrid.RemoveComment(i,j);
  MyAdvGrid.Invalidate;
end;

end.
